package org.nuiton.util;

/*
 * #%L
 * Nuiton Utils :: Nuiton Utils
 * $Id: PagerBean.java 2591 2013-07-22 15:16:12Z athimel $
 * $HeadURL: http://svn.nuiton.org/svn/nuiton-utils/tags/nuiton-utils-2.7/nuiton-utils/src/main/java/org/nuiton/util/PagerBean.java $
 * %%
 * Copyright (C) 2004 - 2012 CodeLutin
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation, either version 3 of the 
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Lesser Public License for more details.
 * 
 * You should have received a copy of the GNU General Lesser Public 
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/lgpl-3.0.html>.
 * #L%
 */

import java.io.Serializable;

import com.google.common.base.Objects;

/**
 * A pager bean.
 * <p/>
 * Was previously {@code org.nuiton.util.PagerUtil.PagerBean}.
 *
 * @author tchemit <chemit@codelutin.com>
 * @since 2.6.2
 */
public class PagerBean implements Serializable {

    private static final long serialVersionUID = 1L;

    /** Number of records (says numbers of rows displayable. */
    protected long records;

    /** Index of the first record in this page. */
    protected long recordStartIndex;

    /** Index of the last record in this page. */
    protected long recordEndIndex;

    /** Index of the page. */
    protected int pageIndex;

    /** Page size, says number of records in a page. */
    protected int pageSize;

    /** Number of pages. */
    protected long pagesNumber;

    public long getRecords() {
        return records;
    }

    public long getRecordStartIndex() {
        return recordStartIndex;
    }

    public long getRecordEndIndex() {
        return recordEndIndex;
    }

    public int getPageIndex() {
        return pageIndex;
    }

    public int getPageSize() {
        return pageSize;
    }

    public long getPagesNumber() {
        return pagesNumber;
    }

    public void setRecords(long records) {
        this.records = records;
    }

    public void setRecordStartIndex(long recordStartIndex) {
        this.recordStartIndex = recordStartIndex;
    }

    public void setRecordEndIndex(long recordEndIndex) {
        this.recordEndIndex = recordEndIndex;
    }

    public void setPageIndex(int pageIndex) {
        this.pageIndex = pageIndex;
    }

    public void setPageSize(int pageSize) {
        this.pageSize = pageSize;
    }

    public void setPagesNumber(long pagesNumber) {
        this.pagesNumber = pagesNumber;
    }

    @Override
    public String toString() {
        String result = Objects.toStringHelper(PagerBean.class)
                .add("records", records)
                .add("recordStartIndex", recordStartIndex)
                .add("recordEndIndex", recordEndIndex)
                .add("pageIndex", pageIndex)
                .add("pageSize", pageSize)
                .add("pagesNumber", pagesNumber)
                .toString();
        return result;
    }

}
